//  DlgCommonProg.cpp : Cve[V t@C
// CG: ̃t@ĆuvOX _CAOvR|[lgɂǉĂ܂B

#include "stdafx.h"
#include "resource.h"
#include "DlgCommonProg.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgCommonProgress _CAO

CDlgCommonProgress::CDlgCommonProgress(UINT nCaptionID)
{
	m_nCaptionID = CG_IDS_PROGRESS_CAPTION;
	if (nCaptionID != 0)
		m_nCaptionID = nCaptionID;

    m_nLower=0;
    m_nUpper=100;
    m_nStep=10;
    //{{AFX_DATA_INIT(CDlgCommonProgress)
    // : ClassWizard ́ÄʒuɃȍR[hǉ܂B
    //}}AFX_DATA_INIT
    m_bParentDisabled = FALSE;
    m_bCanceled = FALSE;//ǉ by Kobarin
}

CDlgCommonProgress::~CDlgCommonProgress()
{
    if(m_hWnd!=NULL)
      DestroyWindow();
}

BOOL CDlgCommonProgress::DestroyWindow()
{
    PumpMessages();
    ReEnableParent();
    return CDialog::DestroyWindow();
}

void CDlgCommonProgress::ReEnableParent()
{
    if(m_bParentDisabled && (m_pParentWnd!=NULL))
      m_pParentWnd->EnableWindow(TRUE);
    m_bParentDisabled=FALSE;
}

void CDlgCommonProgress::EnableCancelButton(BOOL bEnable)
{
	GetDlgItem(IDCANCEL)->EnableWindow(bEnable);
}

BOOL CDlgCommonProgress::Create(CWnd *pParent)
{
    // _CAO̎ۂ̐eEBhE擾܂B
    m_pParentWnd = CWnd::GetSafeOwner(pParent);

    // m_bParentDisabled ́Ã_CAOjꂽɁAeEBhE
    // ĂїLɂ邽߂Ɏgp܂B]āA̎_ŐeEBhEł
    // Lȏꍇ̂݁A̕ϐ TRUE ݒ肵܂B

    if((m_pParentWnd!=NULL) && m_pParentWnd->IsWindowEnabled())
    {
      m_pParentWnd->EnableWindow(FALSE);
      m_bParentDisabled = TRUE;
    }

    if(!CDialog::Create(CDlgCommonProgress::IDD,pParent))
    {
      ReEnableParent();
      return FALSE;
    }

    return TRUE;
}

void CDlgCommonProgress::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CDlgCommonProgress)
    DDX_Control(pDX, CG_IDC_PROGDLG_PROGRESS, m_Progress);
    //}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDlgCommonProgress, CDialog)
    //{{AFX_MSG_MAP(CDlgCommonProgress)
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()


void CDlgCommonProgress::OnCancel()
{
	//ǉ by Kobarin
	if (MessageBox("fĂ낵łH", "̒f", MB_ICONQUESTION|MB_YESNOCANCEL|MB_DEFBUTTON2|MB_TOPMOST) == IDYES) {
		m_bCanceled = TRUE;
	}
}

void CDlgCommonProgress::SetRange(int nLower,int nUpper)
{
    m_nLower = nLower;
    m_nUpper = nUpper;
    m_Progress.SetRange(nLower,nUpper);
}
  
int CDlgCommonProgress::SetPos(int nPos)
{
    int iResult = TRUE;
    PumpMessages();
	if (GetSafeHwnd() != NULL) {
		m_Progress.SetPos(nPos);
		UpdatePercent(nPos);
	}
    return iResult;
}

int CDlgCommonProgress::SetStep(int nStep)
{
    m_nStep = nStep; // Ńp[Ze[W̌vZsۂɗp܂B
    return m_Progress.SetStep(nStep);
}

int CDlgCommonProgress::OffsetPos(int nPos)
{
    PumpMessages();
    int iResult = m_Progress.OffsetPos(nPos);
    UpdatePercent(iResult+nPos);
    return iResult;
}

int CDlgCommonProgress::StepIt()
{
    PumpMessages();
    int iResult = m_Progress.StepIt();
    UpdatePercent(iResult+m_nStep);
    return iResult;
}

void CDlgCommonProgress::PumpMessages()
{
    // _CAOgpO Create() ĂłB
	if (GetSafeHwnd() == NULL) return;
//    ASSERT(m_hWnd!=NULL);

    MSG msg;
    // _CAO bZ[W̏
    while(PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
    {
      if(!IsDialogMessage(&msg))
      {
        TranslateMessage(&msg);
        DispatchMessage(&msg);  
		if (GetSafeHwnd() == NULL) break;
      }
    }
}


void CDlgCommonProgress::UpdatePercent(int nNewPos)
{
    CWnd *pWndPercent = GetDlgItem(CG_IDC_PROGDLG_PERCENT);
    int nPercent;
    
    int nDivisor = m_nUpper - m_nLower;
    ASSERT(nDivisor>0);  // m_nLower  m_nUpper łȂ΂܂B

    int nDividend = (nNewPos - m_nLower);
    ASSERT(nDividend>=0);   // ݈ʒu m_nLower ȏłȂ΂܂B

    nPercent = nDividend * 100 / nDivisor;

    // vOX Rg[͐܂Ԃ\Ȃ̂ŁAɉăp[Ze[W
    // ܂Ԃ悤ɂ܂BA]ہA100%  0% ƂĂ͂܂B
    if(nPercent!=100)
      nPercent %= 100;

    // p[Ze[W\܂B
    CString strBuf;
    strBuf.Format(_T("%d%c"),nPercent,_T('%'));

	CString strCur; // ݂̃p[Ze[W擾
    pWndPercent->GetWindowText(strCur);

	if (strCur != strBuf)
		pWndPercent->SetWindowText(strBuf);
}
    
/////////////////////////////////////////////////////////////////////////////
// CDlgCommonProgress bZ[W nh

BOOL CDlgCommonProgress::OnInitDialog() 
{
    CDialog::OnInitDialog();
    m_Progress.SetRange(m_nLower,m_nUpper);
    m_Progress.SetStep(m_nStep);
    m_Progress.SetPos(m_nLower);

	CString strCaption;
	VERIFY(strCaption.LoadString(m_nCaptionID));
    SetWindowText(strCaption);

    return TRUE;  
}
